Class | Rake::Task
In: | lib/rake.rb
Parent: | Object

A Task is the basic unit of work in a Rakefile. Tasks have associated actions (possibly more than one) and a list of prerequisites. When invoked, a task will first ensure that all of its prerequisites have an opportunity to run and then it will execute its own actions.

Tasks are not usually created directly using the new method, but rather use the `file` and `task` convenience methods.

### Methods

[] add_description arg_names clear clear clear_actions clear_prerequisites comment= create_rule define_task enhance execute inspect investigation invoke name needed? new reenable scope_name set_arg_names source sources task_defined? tasks timestamp to_s

### Attributes

actions | [R] | List of actions attached to a task.
application | [RW] | Application owning this task.
comment | [R] | Comment for this task. Restricted to a single line of no more than 50 characters.
full_comment | [R] | Full text of the (possibly multi-line) comment.
prerequisites | [R] | List of prerequisites for a task.
scope | [R] | Array of nested namespaces names used for task lookup by this task.
sources | [W] | List of sources for task.

### Public Class methods

[](task_name)

Return a task with the given name. If the task is not currently known, try to synthesize one from the defined rules. If no rules are found, but an existing file matches the task name, assume it is a file task with no dependencies or actions.

clear()

Clear the task list. This cause rake to immediately forget all the tasks that have been assigned. (Normally used in the unit tests.)

create_rule(*args, &block)

Define a rule for synthesizing tasks.

define_task(*args, &block)

Define a task given `args` and an option block. If a rule with the given name already exists, the prerequisites and actions are added to the existing task. Returns the defined task.

new(task_name, app)

Create a task named `task_name` with no actions or prerequisites. Use `enhance` to add actions and prerequisites.

scope_name(scope, task_name)

Apply the scope to the task name according to the rules for this kind of task. Generic tasks will accept the scope as part of the name.

task_defined?(task_name)

TRUE if the task name is already defined.

tasks()

List of all defined tasks.

### Public Instance methods

add_description(description)

Add a description to the task. The description can consist of an option argument list (enclosed brackets) and an optional comment.

arg_names()

Name of arguments for this task.

clear()

Clear the existing prerequisites and actions of a rake task.

clear_actions()

Clear the existing actions on a rake task.

clear_prerequisites()

Clear the existing prerequisites of a rake task.

comment=(description)

Writing to the comment attribute is the same as adding a description.

enhance(deps=nil, &block)

Enhance a task with prerequisites or actions. Returns self.

execute(args=nil)

Execute the actions associated with this task.

inspect()
investigation()

Return a string describing the internal state of a task. Useful for debugging.

invoke(*args)

Invoke the task if it is needed. Prerequites are invoked first.

name()

Name of the task, including any namespace qualifiers.

needed?()

Is this task needed?

reenable()

Reenable the task, allowing its tasks to be executed if the task is invoked again.

set_arg_names(args)

Set the names of the arguments for this task. `args` should be an array of symbols, one for each argument name.

source()

First source from a rule (nil if no sources)

sources()
timestamp()

Timestamp for this task. Basic tasks return the current time for their time stamp. Other tasks can be more sophisticated.

to_s()

Return task name

[Validate]